function [im_t_t, Ou,best_net_accuracy]=NeuralNetwork;
global bands; global rx;global ry; global year;

fprintf('Load the traning data...');
% nxm x 1 an image that contain the information about ONE class
bands=1;
temp_target=LoadImSet;

fprintf('\nLoad the Original data...');
bands=6;
% bands=input('How many bands you will use?: ');
imset1=LoadImSet;
[rx ry rn]= size(imset1);

% We are defining by x and y an 256x256 area in the part of the image where
% we have the training data.
x=[379;634]; y=[492;747];


% Uncomment the following four lines to show the image that contain the 
% training data,%and select the area to be classified or use cc1(imset1) to 
% show the false color composit.

% imagesc(temp_target), pixval on;axis image;
% fprintf('\nSelect TWO points top-left and bottom-right to defin an area to be used in classification.\n');
% [x y] = (ginput(2));
% x=round(x);y=round(y);

temp_target=temp_target(y(1):y(2),x(1):x(2));
[rx ry rn]= size(temp_target);

temp_target=reshape(temp_target,rx*ry,1);
[R,C,V] = find(temp_target>0);
temp_target(R,:)=1;
temp_target=reshape(temp_target,rx,ry,1);

imset1=imset1(y(1):y(2),x(1):x(2),:);
%cc1(imset1)

set1=double(reshape(imset1,rx*ry,bands));
indata=set1';

% the max value is the only none-zero value that define the class regions.

temp_target=reshape(temp_target,rx*ry,1);
mv=max(temp_target);

[R,C,V] = find(temp_target==0);
target(R,:)=0;

[R,C,V] = find(temp_target==mv);
target(R,:)=1;

target= target';

best_net_accuracy=0;
% best_net_accuracy is  initialized to 0.
tic;
for n=1:3
  input_ranges=minmax(indata);
  net=newff(input_ranges,[2 1],{'tansig','logsig'},'trainlm');

  training_in     = indata(:,1:2:length(indata));
  testset.P       = indata(:,2:2:length(indata));

  training_target = target(1:2:length(target));
  testset.T       = target(2:2:length(target));

  net.trainParam.show=1;
  [net training_record]=train(net,training_in,training_target,[],[],testset);
  net_accuracy=accuracy(net,testset.P,testset.T);	
  if (net_accuracy>best_net_accuracy) 
     best_net=net;
     best_net_accuracy=net_accuracy;		
     disp 'This is the most accurate network so far!'
  else
     disp 'This network is worse than the best!'
  end;
  disp('Accuracy:')
  disp(accuracy(net,testset.P,testset.T))
end;

disp('The Best Network:');
disp('Accuracy:')
disp(best_net_accuracy)

toc

im_t_t=reshape(temp_target,rx,ry,1);
figure(1),imagesc(im_t_t),axis image, title 'The training data', pixval on;colormap gray;

cc1(imset1);
output=sim(best_net, indata);
Ou=reshape(output,rx,ry);
figure(2),imagesc(Ou), title 'The classified image' , axis image,pixval on;

s=input('Do you want to save the classified image(Y/N): ','s');
if s=='Y'
    fprintf('Saving Variabels...\n');
    savefile = strcat(year,'classified ','.mat');
    save(savefile, 'Ou')
%imwrite(Ou, strcat(num2str(year),'-classified ','.tif'), 'tif'); To save
%as a *.tif file
end