
function ann;
global year;
year=input('The first setdata is from year: ','s'); % is a string to allow letters also
[input1, output1,best_net_accuracy1]=NeuralNetwork;
s=input('You can try again. Are you satisfied with the result?(Y/N): ','s');
if s=='N'
    [input1,output1,best_net_accuracy1]=NeuralNetwork;
end
t1=input('Input the threshold value for the first classified image: ')
[xr,yr]=size(output1);
Routput1=reshape(output1,xr*yr,1);
[R,C,V] = find(Routput1>t1);
Thoutput1=zeros(xr*yr,1);
Thoutput1(R,:)=10;
RThoutput1=reshape(Thoutput1,xr,yr,1);
figure(3),imagesc(RThoutput1),axis image, pixval on;colormap gray,title 'The thresholded-classified image 1993'

s=input('Do you want to save the classified image(Y/N): ','s');
if s=='Y'
    fprintf('Saving Variabels...\n');
    savefile = strcat(year,'classified ','.mat');
    save(savefile, 'output1')
end

clear year; global year;
year=input('The second set data is from year: ','s');
[input2,output2,best_net_accuracy2]=NeuralNetwork;
s=input('You can try again. Are you satisfied with the result?(Y/N): ','s');
if s=='N'
    [input2,output2,best_net_accuracy2]=NeuralNetwork;
end
t2=input('Input the threshold value for the second classified image: ');
Routput2=reshape(output2,xr*yr,1);
[R,C,V] = find(Routput2>t2);
Thoutput2=zeros(xr*yr,1);
Thoutput2(R,:)=20;
RThoutput2=reshape(Thoutput2,xr,yr,1);
figure(4),imagesc(RThoutput2),axis image, pixval on;colormap gray,title 'The Thresholded-classified image 1998'

s=input('Do you want to save the classified image(Y/N): ','s');
if s=='Y'
    fprintf('Saving Variabels...\n');
    savefile= strcat(year,'-classified ','.mat');
    save(savefile, 'Thoutput2')
end

% combining the training data
Rinput1=reshape(input1,xr*yr,1);
Rinput2=reshape(input2,xr*yr,1);

[R1,C1,V1] = find(Rinput1>0);
Rinput1(R1,:)=10;

[R2,C2,V2] = find(Rinput2>0);
Rinput2(R2,:)=20;

CombinedTr=Rinput1+Rinput2;
[R3,C3,V3] = find(CombinedTr==30);
RCombinedTr=reshape(CombinedTr, xr,yr,1);
figure(5),imagesc(RCombinedTr),axis image, pixval on;title 'The combined changes 1993-1998'

% combining the resuts
CombinedRes=Thoutput1+Thoutput2;
RCombinedRes=reshape(CombinedRes, xr,yr,1);
figure(6),imagesc(RCombinedRes),axis image, pixval on;title 'The combined changes 1993-1998'

%%%%%%%%%%%%%%
accass=input('Do you want to comput the Confusion matrix: ','s');
if accass=='Y'
coveredAtEnd=find(CombinedTr==10);
uncoveredAtEnd=find(CombinedTr==20);
notChanges=find(CombinedTr==30);

    numOfCpT=size(coveredAtEnd,1); % number of coverd pixels in the training data
    numOfUpT=size(uncoveredAtEnd,1);% number of umcoverd pixels in the training data
    numOfNpT=size(notChanges,1);% number of No-change pixels in the training data

    %first classname
    % we use the same variable (i.e rewrite) idxCpI, idxUpI and idxNpI each time 
    tmp=CombinedRes(coveredAtEnd);
    idxCpI=(find(tmp==10));numOfCCpI=size(idxCpI,1);% number of pixels correctly classified in the covered class 
    idxCpI=(find(tmp==20));numOfCUpI=size(idxCpI,1);% number of pixels classified as uncoverd in the covered class
    idxCpI=(find(tmp==0)); numOfCNpI=size(idxCpI,1);% number of pixels classified as No-change in the covered class
    idxNCC=(find(tmp==30)); numOfNCC=size(idxNCC,1);% number of pixels No-change as No-change in the covered class
    %second classname
    tmp=CombinedRes(uncoveredAtEnd);
    idxUpI=(find(tmp==10));numOfUCpI=size(idxUpI,1);% number of pixels classified as coverd in the uncovered class
    idxUpI=(find(tmp==20));numOfUUpI=size(idxUpI,1);% number of pixels correctly classified in the uncovered class 
    idxUpI=(find(tmp==0)) ;numOfUNpI=size(idxUpI,1);% number of pixels classified as No-change in the uncovered class
    idxNCU=(find(tmp==30)); numOfNCC=size(idxNCU,1); % number of pixels No-change as No-change in the uncovered class
    %third classname
    tmp=CombinedRes(notChanges);
    idxNpI=(find(tmp==10));numOfNCpI=size(idxNpI,1);% number of pixels classified as coverd in the No change class
    idxNpI=(find(tmp==20));numOfNUpI=size(idxNpI,1);% number of pixels classified as umcoverd in the No change class
    idxNpI=(find(tmp==0)) ;numOfNNpI=size(idxNpI,1);% number of pixels classified as background in the No change class 
    idxNCN=(find(tmp==30)); numOfNCC=size(idxNCN,1);% number of No change pixels correctly classified in the No change class 
    SumOfCol1=numOfCCpI+numOfCUpI+numOfCNpI;
    SumOfCol2=numOfUCpI+numOfUUpI+numOfUNpI;
    SumOfCol3=numOfNCpI+numOfNUpI+numOfNNpI;

    %Sum of rows
    SumOfRow1=numOfCCpI+numOfUCpI+numOfNCpI;
    SumOfRow2=numOfCUpI+numOfUUpI+numOfNUpI;
    SumOfRow3=numOfCNpI+numOfUNpI+numOfNNpI;

    % Sum of diag (i.e. Correctly classified)
    SumOfDiag=numOfCCpI+numOfUUpI+numOfNNpI;

    % Producer's accuracy - % Ucer's accuracy
    prodAcc1=numOfCCpI/SumOfCol1;
    userAcc1=numOfCCpI/SumOfRow1;

    prodAcc2=numOfUUpI/SumOfCol2;
    userAcc2=numOfUUpI/SumOfRow2;

    prodAcc3=numOfNNpI/SumOfCol3;
    userAcc3=numOfNNpI/SumOfRow3;

    P1=prodAcc1*prodAcc2*prodAcc3;
    P2=userAcc1*userAcc2*userAcc3;
    
    SUMofsumOfColumns=SumOfCol1+SumOfCol2+SumOfCol3;
    SUMofsumOfRows=SumOfRow1+SumOfRow2+SumOfRow3;
   
    OverAllAcc=SumOfDiag/(SUMofsumOfColumns);

    % Kappa statistics 
    PC1=SumOfCol1/SUMofsumOfColumns; % Percentage Column 1
    PC2=SumOfCol2/SUMofsumOfColumns;
    PC3=SumOfCol3/SUMofsumOfColumns;

    PR1=SumOfRow1/SUMofsumOfColumns;% Percentage Row 1
    PR2=SumOfRow2/SUMofsumOfColumns;
    PR3=SumOfRow3/SUMofsumOfColumns;

    ExpectedAcc=(PC1*PR1+PC2*PR2+PC3*PR3);

    Kappa=(OverAllAcc-ExpectedAcc)/(1-ExpectedAcc);

    wr=input('Do you want to write the results to an xls file?(Y/N): ','s');
    if wr=='Y'
    % Writing to an excel file
        fprintf('Writing the accuracy assessment to an excel file...\n');

        accass=strcat('The Accuracy assessment( ',  sheet,')' );
        xlswrite(filename,{accass} , sheet, 'C1');
        xlswrite(filename,{'uncovered to covered(green)'} , sheet, 'B4');
        xlswrite(filename,{'cover to uncovered(red)'} , sheet, 'C4');
        xlswrite(filename,{'unchanged'} , sheet, 'D4');

        xlswrite(filename,{'uncovered to covered(green)'} , sheet, 'A5');
        xlswrite(filename,{'cover to uncovered(red)'} , sheet, 'A6');
        xlswrite(filename,{'unchanged'} , sheet, 'A7');

        % Writing values
        % The first class
        xlswrite(filename, numOfCCpI, sheet, 'B5');
        xlswrite(filename, numOfCUpI, sheet, 'B6');
        xlswrite(filename, numOfCNpI, sheet, 'B7');

        % The second class
        xlswrite(filename, numOfUCpI, sheet, 'C5');
        xlswrite(filename, numOfUUpI, sheet, 'C6');
        xlswrite(filename, numOfUNpI, sheet, 'C7');

        % The third class
        xlswrite(filename, numOfNCpI, sheet, 'D5');
        xlswrite(filename, numOfNUpI, sheet, 'D6');
        xlswrite(filename, numOfNNpI, sheet, 'D7');

        % Sum of columns
        xlswrite(filename, {'Sum of columns'}, sheet, 'A9');
        xlswrite(filename, SumOfCol1, sheet, 'B9');
        xlswrite(filename, SumOfCol2, sheet, 'C9');
        xlswrite(filename, SumOfCol3, sheet, 'D9');

        %Sum of rows
        xlswrite(filename, {'Sum of rows'}, sheet, 'F4');
        xlswrite(filename, SumOfRow1, sheet, 'F5');
        xlswrite(filename, SumOfRow2, sheet, 'F6');
        xlswrite(filename, SumOfRow3, sheet, 'F7');

        % Sum of diag (i.e. Correctly classified)
        xlswrite(filename, {'Sum of Diagonal'}, sheet, 'G9');
        xlswrite(filename, SumOfDiag, sheet, 'F9');


        % Sum of (sum of colomns)
        xlswrite(filename, {'Sum of (Sum of columns)'}, sheet, 'H8');
        xlswrite(filename, SUMofsumOfColumns, sheet, 'G8');

        % Sum of (sum of rows)
        xlswrite(filename, {'Sum of (Sum of rows)'}, sheet, 'H10');
        xlswrite(filename, SUMofsumOfRows, sheet, 'G10');

        % Producer's accuracy - % Ucer's accuracy
        xlswrite(filename,{'Producer Accuracy'} , sheet, 'A11');
        xlswrite(filename,{'User Accuracy'} , sheet, 'A12');
        xlswrite(filename,{'Over all Accuracy'} , sheet, 'A13');
        xlswrite(filename,{'Kappa'} , sheet, 'A14');

        xlswrite(filename, prodAcc1, sheet, 'B11');
        xlswrite(filename, prodAcc2, sheet, 'C11');
        xlswrite(filename, prodAcc3, sheet, 'D11');

        xlswrite(filename, userAcc1, sheet, 'B12');
        xlswrite(filename, userAcc2, sheet, 'C12');
        xlswrite(filename, userAcc3, sheet, 'D12');

        xlswrite(filename, OverAllAcc, sheet, 'B13');

        xlswrite(filename, Kappa, sheet, 'B14');


        xlswrite(filename, P1, sheet, 'F11');
        xlswrite(filename, P2, sheet, 'F12');
    end
end

        

fprintf('\nANN Done .\n')


